function _arrayLikeToArray(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _arrayWithHoles(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterableToArrayLimit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _nonIterableRest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _slicedToArray(arr, i) {
    return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}
function _unsupportedIterableToArray(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _arrayLikeToArray(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
import path from "path";
import { fs, slash } from "@modern-js/utils";
import { types as t } from "@babel/core";
var replaceValueHash = {};
var getImportFileDistPath = function(importName, currentFilename, opts) {
    var _opts_staticDir = opts.staticDir, staticDir = _opts_staticDir === void 0 ? "." : _opts_staticDir, _opts_styleDir = opts.styleDir, styleDir = _opts_styleDir === void 0 ? "." : _opts_styleDir;
    var currentFileDir = path.dirname(currentFilename);
    var _opts_sourceDir;
    var crtFileRELSrcPath = path.relative(currentFileDir, (_opts_sourceDir = opts.sourceDir) !== null && _opts_sourceDir !== void 0 ? _opts_sourceDir : currentFileDir);
    var _opts_sourceDir1;
    var importFileRELSrcPath = path.relative((_opts_sourceDir1 = opts.sourceDir) !== null && _opts_sourceDir1 !== void 0 ? _opts_sourceDir1 : currentFileDir, path.join(currentFileDir, importName));
    var resourceDir = isStyleFile(importName) ? styleDir : staticDir;
    var ret = path.join(crtFileRELSrcPath, resourceDir, importFileRELSrcPath);
    return ret.startsWith(".") ? slash(ret) : slash("./".concat(ret));
};
var isNotJsLikeFile = function(importFileName, currentCompileFile) {
    var tests = [
        [
            /\.js$/,
            ".js"
        ],
        [
            /\.jsx$/,
            ".jsx"
        ],
        [
            /\.ts$/,
            ".ts"
        ],
        [
            /\.tsx$/,
            ".tsx"
        ]
    ];
    return !tests.some(function(param) {
        var _param = _slicedToArray(param, 2), regex = _param[0], prefix = _param[1];
        return regex.test(importFileName) || fs.existsSync(path.join(path.dirname(currentCompileFile), importFileName) + prefix) || fs.existsSync(path.join(path.dirname(currentCompileFile), importFileName, "index") + prefix);
    });
};
var isStyleFile = function(file) {
    var tests = [
        /\.css$/,
        /\.less$/,
        /\.sass$/,
        /\.scss$/
    ];
    return tests.some(function(regex) {
        return regex.test(file);
    });
};
var isShouldSkip = function(importName, filename) {
    if (importName.startsWith("./") || importName.startsWith("../")) {
        if (isNotJsLikeFile(importName, filename)) {
            return false;
        }
    }
    return true;
};
var getReplacePath = function(opts, importName, currentFilename) {
    var importStyle = opts.importStyle;
    if (!currentFilename || !importName) {
        return "";
    }
    if (isShouldSkip(importName, currentFilename)) {
        return "";
    }
    var realFilepath = getImportFileDistPath(importName, currentFilename, opts);
    if (isStyleFile(realFilepath) && importStyle === "compiled-code") {
        realFilepath = realFilepath.replace(/\.(less|sass|scss)$/, ".css");
    }
    return realFilepath;
};
var importPath = function() {
    return {
        name: "import-path",
        pre: function pre() {
            replaceValueHash = {};
        },
        visitor: {
            Program: function Program(nodePath, param) {
                var opts = param.opts, file = param.file;
                nodePath.traverse({
                    ImportDeclaration: function ImportDeclaration(param) {
                        var node = param.node;
                        var source = node.source;
                        var filename = file.opts.filename;
                        var importName = (source === null || source === void 0 ? void 0 : source.value) ? source.value : void 0;
                        var replaceValue = getReplacePath(opts, importName, filename);
                        var hashKey = filename + (importName || "");
                        if (replaceValue) {
                            if (typeof filename === "string" && !replaceValueHash[hashKey]) {
                                node.source.value = replaceValue;
                                replaceValueHash[hashKey] = replaceValue;
                            } else if (typeof filename === "string" && replaceValueHash[hashKey]) {
                                node.source.value = replaceValueHash[hashKey];
                            } else {
                                node.source.value = replaceValue;
                            }
                        }
                    },
                    CallExpression: function CallExpression(param) {
                        var node = param.node;
                        var filename = file.opts.filename;
                        var callee = node.callee, args = node.arguments;
                        if (callee.type === "Import" || callee.type === "Identifier" && callee.name === "require") {
                            var firstArg = args[0];
                            if (firstArg.value) {
                                var importName = firstArg.value;
                                var replaceValue = getReplacePath(opts, importName, filename);
                                var hashKey = filename + (importName || "");
                                if (replaceValue) {
                                    if (typeof filename === "string" && !replaceValueHash[hashKey]) {
                                        node.arguments = [
                                            t.stringLiteral(replaceValue)
                                        ];
                                        replaceValueHash[hashKey] = replaceValue;
                                    } else if (typeof filename === "string" && replaceValueHash[hashKey]) {
                                        node.arguments = [
                                            t.stringLiteral(replaceValueHash[hashKey])
                                        ];
                                    } else {
                                        node.arguments = [
                                            t.stringLiteral(replaceValue)
                                        ];
                                    }
                                }
                            }
                        }
                    }
                });
            }
        }
    };
};
var import_path_default = importPath;
export { import_path_default as default, getImportFileDistPath, getReplacePath, isNotJsLikeFile, isShouldSkip, isStyleFile };
